#!/bin/sh
DN=$(cd "${0%/*}" && pwd)

unset APA_VER CONF_FILE

while getopts c:v:i: c ; do
  case $c in
    c) CONF_FILE=$OPTARG ;;
    v) APA_VER=$OPTARG ;;
    i) INITIAL_VERSION=$OPTARG ;;
  esac
done

INITIAL_VERSION=`expr $INITIAL_VERSION + 0 2>/dev/null`
[ ${#INITIAL_VERSION} -gt 18 ] && INITIAL_VERSION=0

grep -q '^APACHE_CONF=.*/' "$CONF_FILE" 2>/dev/null || exit 0

[ -n "${APA_VER#.}" ] && SUFFIX=-$APA_VER-$INITIAL_VERSION || SUFFIX=-$INITIAL_VERSION

export OFS=$IFS
IFS='\\'
for i in `awk -F= '/^APACHE_CONF=/{print $2}' < $CONF_FILE` ; do
 if [ -f "$i".unlimited. ] ; then
    cat "$i".unlimited. > "$i"
  elif [ ! -f "$i".unlimit. ] ; then
    /bin/cp -p "$i" "$i".unlimit.
  fi
done
IFS=$OFS

exit 0
