IF OBJECT_ID('i_CreditCheckAgencyCustGroup') IS NOT NULL
    DROP PROCEDURE i_CreditCheckAgencyCustGroup
GO
CREATE PROCEDURE i_CreditCheckAgencyCustGroup (
    @CreditCheckAgencyConfigID int          
,   @CustomerGroupID      int          
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_creditcheckagencycustgroup
    ELSE                     BEGIN TRANSACTION ti_creditcheckagencycustgroup

        INSERT INTO creditcheckagencycustgroup
               ( creditcheckagencyconfigid, customergroupid)
        SELECT  @CreditCheckAgencyConfigID,@CustomerGroupID

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_creditcheckagencycustgroup
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_creditcheckagencycustgroup
    RETURN 0
END
GO
