IF OBJECT_ID('i_CreditCheckAgencyPayment') IS NOT NULL
    DROP PROCEDURE i_CreditCheckAgencyPayment
GO
CREATE PROCEDURE i_CreditCheckAgencyPayment (
    @CreditCheckAgencyConfigID int          
,   @PaymentMethodID      int          
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_creditcheckagencypayment
    ELSE                     BEGIN TRANSACTION ti_creditcheckagencypayment

        INSERT INTO creditcheckagencypayment
               ( creditcheckagencyconfigid, paymentmethodid)
        SELECT  @CreditCheckAgencyConfigID,@PaymentMethodID

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_creditcheckagencypayment
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_creditcheckagencypayment
    RETURN 0
END
GO
