IF OBJECT_ID('i_CreditCheckAgencyPriceLimit') IS NOT NULL
    DROP PROCEDURE i_CreditCheckAgencyPriceLimit
GO
CREATE PROCEDURE i_CreditCheckAgencyPriceLimit (
    @CreditCheckAgencyConfigID int          
,   @CurrencyID           char(3)      
,   @MinAmount            money        = null
,   @MaxAmount            money        = null
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_creditcheckagencypricelimit
    ELSE                     BEGIN TRANSACTION ti_creditcheckagencypricelimit

        INSERT INTO creditcheckagencypricelimit
               ( creditcheckagencyconfigid, currencyid, minamount, maxamount)
        SELECT  @CreditCheckAgencyConfigID,@CurrencyID,@MinAmount,@MaxAmount

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_creditcheckagencypricelimit
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_creditcheckagencypricelimit
    RETURN 0
END
GO
