IF OBJECT_ID('i_DHLProdListDeliveryDest') IS NOT NULL
    DROP PROCEDURE i_DHLProdListDeliveryDest
GO
CREATE PROCEDURE i_DHLProdListDeliveryDest (
    @DHLProdListDeliveryDestID int          = null
,   @CountryCode          varchar(3)   
,   @CurrencyID           varchar(3)   = null
,   @DHLProductListID     int          = null
,   @Exceptions           varchar(255) = null
,   @OverallPriceAmountEur money        = null
,   @OverallPriceDisplayName varchar(255) = null
,   @Declaration          varchar(255) = null
,   @CN22Limit            float        = null
,   @Endorsement          bit          
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_dhlprodlistdeliverydest
    ELSE                     BEGIN TRANSACTION ti_dhlprodlistdeliverydest

        IF @DHLProdListDeliveryDestID IS NULL SELECT @DHLProdListDeliveryDestID = 1 + max(dhlprodlistdeliverydestid) FROM dhlprodlistdeliverydest HOLDLOCK
        IF @DHLProdListDeliveryDestID IS NULL SELECT @DHLProdListDeliveryDestID = 1

        INSERT INTO dhlprodlistdeliverydest
               ( dhlprodlistdeliverydestid, countrycode, currencyid, dhlproductlistid, exceptions, overallpriceamounteur, overallpricedisplayname, declaration, cn22limit, endorsement)
        SELECT  @DHLProdListDeliveryDestID,@CountryCode,@CurrencyID,@DHLProductListID,@Exceptions,@OverallPriceAmountEur,@OverallPriceDisplayName,@Declaration,@CN22Limit,@Endorsement

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_dhlprodlistdeliverydest
            RETURN 1
        END

        SELECT @DHLProdListDeliveryDestID

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_dhlprodlistdeliverydest
    RETURN 0
END
GO
