IF OBJECT_ID('i_DHLProductList') IS NOT NULL
    DROP PROCEDURE i_DHLProductList
GO
CREATE PROCEDURE i_DHLProductList (
    @DHLProductListID     int          = null
,   @ProductID            varchar(255) 
,   @Supplier             varchar(255) = null
,   @DisplayName          varchar(255) = null
,   @PictureURL           varchar(255) = null
,   @ValidFrom            datetime     = null
,   @ValidTo              datetime     = null
,   @WeightKgMin          float        = null
,   @WeightKgMax          float        = null
,   @LengthCmMin          float        = null
,   @LengthCmMax          float        = null
,   @WidthCmMin           float        = null
,   @WidthCmMax           float        = null
,   @HeightCmMin          float        = null
,   @HeightCmMax          float        = null
,   @LengthWidthHeightCmMin float        = null
,   @LengthWidthHeightCmMax float        = null
,   @URL                  varchar(255) = null
,   @TOS                  varchar(255) = null
,   @PrintAdvice          varchar(255) = null
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_dhlproductlist
    ELSE                     BEGIN TRANSACTION ti_dhlproductlist

        IF @DHLProductListID IS NULL SELECT @DHLProductListID = 1 + max(dhlproductlistid) FROM dhlproductlist HOLDLOCK
        IF @DHLProductListID IS NULL SELECT @DHLProductListID = 1

        INSERT INTO dhlproductlist
               ( dhlproductlistid, productid, supplier, displayname, pictureurl, validfrom, validto, weightkgmin, weightkgmax, lengthcmmin, lengthcmmax, widthcmmin, widthcmmax, heightcmmin, heightcmmax, lengthwidthheightcmmin, lengthwidthheightcmmax, url, tos, printadvice)
        SELECT  @DHLProductListID,@ProductID,@Supplier,@DisplayName,@PictureURL,@ValidFrom,@ValidTo,@WeightKgMin,@WeightKgMax,@LengthCmMin,@LengthCmMax,@WidthCmMin,@WidthCmMax,@HeightCmMin,@HeightCmMax,@LengthWidthHeightCmMin,@LengthWidthHeightCmMax,@URL,@TOS,@PrintAdvice

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_dhlproductlist
            RETURN 1
        END

        SELECT @DHLProductListID

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_dhlproductlist
    RETURN 0
END
GO
