-- #104
CREATE TABLE shippinglabel (
    shippinglabelid      int           not null
,   shippingtransactionid int           null
,   shippingfulfillmentmethodid int           null
,   trackingid           varchar(255)  null
,   trackinglink         varchar(255)  null
,   productcode          varchar(32)   null
,   shippingfulfillmentproductid int           null
,   labelstatus          tinyint       null
,   totalweight          float         null
,   weightunitid         int           not null
,   amount               money         null
,   currencyid           char(3)       null
,   couponcode           varchar(255)  null
,   insurance            tinyint       null
,   expressdelivery      tinyint       null
,   pickupservice        bit           not null
,   pickupdate           datetime      null
,   labeldownloadurl     varchar(255)  null
,   estimateddeliverydate datetime      null
,   actualdeliverydate   datetime      null
,   parcellength         float         null
,   parcelwidth          float         null
,   parceldepth          float         null
,   sizeunitid           int           not null
,   istestlabel          bit           not null

,   constraint pk_shippinglabel                 primary key (shippinglabelid)
,   constraint fk_shippinglabel_orderdocument   foreign key (shippinglabelid)
        references orderdocument                    (orderdocumentid)
,   constraint fk_shippinglabel_shippingtrans   foreign key (shippingtransactionid)
        references shippingtransaction              (shippingtransactionid)
,   constraint fk_shippinglabel_shippingfulfi   foreign key (shippingfulfillmentmethodid)
        references shippingfulfillmentmethod        (shippingfulfillmentmethodid)
,   constraint fk_shippinglabel_unitofmeasure   foreign key (weightunitid)
        references unitofmeasurement                (unitid)
,   constraint fk_shippinglabel_currency        foreign key (currencyid)
        references currency                         (currencyid)
,   constraint fk_shippinglabel_unitofmeas_1    foreign key (sizeunitid)
        references unitofmeasurement                (unitid)
,   constraint fk_shippinglabel_shippingfu_1    foreign key (shippingfulfillmentproductid)
        references shippingfulfillmentproduct       (shippingfulfillmentproductid)
)
GO
CREATE INDEX w_trackingid ON shippinglabel (trackingid)
GO
CREATE INDEX w_productcode ON shippinglabel (productcode)
GO
CREATE INDEX i_labelstatus ON shippinglabel (labelstatus)
GO
CREATE INDEX i_fulfillmentmethodid ON shippinglabel (shippingfulfillmentmethodid)
GO
CREATE INDEX i_productid ON shippinglabel (shippingfulfillmentproductid)
GO
CREATE INDEX w_weightunitid ON shippinglabel (weightunitid)
GO
CREATE INDEX w_sizeunitid ON shippinglabel (sizeunitid)
GO
CREATE INDEX w_currencyid ON shippinglabel (currencyid)
GO
CREATE INDEX i_shippingtransactionid ON shippinglabel (shippingtransactionid)
GO
