/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			ep.modify
 *
 * @revision		$Revision: 1.2.2.4 $
 */

jQuery.plugin( 'ep.modify', function( $, undefined ){

// modify $.attr + $.removeAttr for event

	// save original methods
	var _attr = $.fn.attr,
		_removeAttr = $.fn.removeAttr;
	// handle for event trigger
	function attrEvent( obj, name, value ){
		var attr;

		if( typeof name === 'object' ){
			attr = name;
		}
		else if( value !== undefined ){
			(attr = {})[ name ] = value;
		}

		if( attr ){
			obj.trigger('changeAttr',attr);
		}
	}
	// overwrite methods
	$.fn.extend({
		attr: function( name, value ){
			var ret = _attr.apply(this,arguments);
			attrEvent( this, name, value );
			return ret;
		},
		removeAttr: function( name ){
			var ret = _removeAttr.apply(this,arguments);
			attrEvent( this, name, null );
			return ret;
		}
	});

	// special pseudo selector for input fields
	$.extend( $.expr[':'],{
		'invalid': function( elem ){
			return !!elem.formInvalid && !elem.disabled;
		}
	});

	// bug fix if target not givn use srcElement currentTarget or originalTarget
	if ( !jQuery.support.changeBubbles ) {
		var _beforeactivate = jQuery.event.special.change.filters.beforeactivate;
		jQuery.event.special.change.filters.focus = jQuery.event.special.change.filters.beforeactivate = function( e ) {
			e.target = e.target || e.srcElement || e.currentTarget || e.originalTarget;
			_beforeactivate(e);
		}
	}

});