/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			ep.ui.coverflow
 *
 * @revision		$Revision: 1.1.2.2.2.4 $
 */

jQuery.plugin( 'ep.ui.coverflow', ['ep.core', 'jQuery.ui.widget', 'jQuery.support.flash', 'jQuery.compareVersion'], function( $, undefined ){


	$.widget('ep.ui.Coverflow',{
		imageData: null,
		titleText: null,
		id: null,
		coverflowModuleSrc: location.protocol + '//' + location.host + ep.config.javascriptRoot + '/ep/ui/Coverflow.swf',
		options: {
		},

		_create: function(){
			this.Inherited(arguments);
			this.id = 'ep_ui_Coverflow_' + idCount++;
			this.imageData = [];
			idStack[this.id] = this.element;
			this.titleText = this.element.attr('title');
			var self = this;
			var imgId = 1;
			var imgNodes = this.element.find("a").each(function(index,elm){
				var elm = $(elm);
				var imgNode = elm.find('img:first');
				self.imageData.push([
					imgNode.attr('src'),
					imgNode.attr('longdesc'),
					elm.attr('href'),
					elm.attr('href2'),
					(imgNode.attr("ismap") ? true : false),
					imgId
				]);
				imgId++;
			});
			if( $.compareVersion($.support.flash,'9') >= 0 ) {
				if(this.imageData.length > 1){
					this.element.removeClass('HideElement');
					this._buildCoverflow();
					this.element.addClass('Flashed');
					$(window).bind('resize',$.proxy(this,'_buildCoverflow'));
				}
				else{
					this.element.removeClass('HideElement');
					$('.ImageSlide').removeClass('HideElement');
					this.element.css({
						'text-align' : 'center',
						'overflow': 'hidden'
					});
				}
			}
			else{
				this.element.removeClass('HideElement');
				$('.ImageSlide, .ImageGalleryListItemContainer').removeClass('HideElement');
			}
		},

		getData: function(){
			return this.imageData;
		},

		addToBasket: function(){
			var currentImageId = $('#'+this.id+'_flash').attr('currentImageId');
			for(var i = 0, iLength = this.imageData.length; i < iLength; i++){
				currentImageData = this.imageData[i];
				if(currentImageId == currentImageData[5] && ep.config.baseUrl && currentImageData[3]){
					var addToBasketLink = ep.config.baseUrl + currentImageData[3];
					//we need to call the addToBasket by AJAX so that the IE is sending a Refererr
					$.ajax({
						type: 'GET',
						url: addToBasketLink,
						async: false,
						success: function(){
							location.reload();
						}
					});

				}
			}
		},

		_buildCoverflow: function() {
			this.element.attr('title',this.titleText);
			if($.browser.msie && parseInt($.browser.version) <= 8){
				//random string is necessary to avoid that the IE thinks he had not to render the flash again
				swfSrc = this.coverflowModuleSrc + "?" + String(Math.floor(Math.random()*9999));
			}
			else{
				swfSrc = this.coverflowModuleSrc;
			}
			this.element.html("<object name='"+this.id+"_flash' id='"+this.id+"_flash' callback='ep(ep.ui.Coverflow.getWidget(\"" + this.id + "\")).uiCoverflow(\"getData\");'  addToBasket='ep(ep.ui.Coverflow.getWidget(\"" + this.id + "\")).uiCoverflow(\"addToBasket\");' currentImageId='' type='application/x-shockwave-flash' data='" + swfSrc + "'> <param name='movie' value='" + swfSrc + "'/> <param name='allowscriptaccess' value='always'/> <param name='wmode' value='transparent'/></object>");
		},

		destroy: function(){
			this.Inherited(arguments);
		}

	});
	var idStack = {};
	var idCount = 1;
	$.extend(ep.ui.Coverflow, {
		getWidget: function(coverflowID){
			return idStack[coverflowID];
		}
	});

});