/*
 * @author			Emanuel Vitzthum
 * @copyright		© 2011 jQuery SDK v1.0
 * @info			http://www.jquerysdk.com
 *
 * @license			Duale licensed under the MIT (http://www.opensource.org/licenses/mit-license.php) and GPL (http://www.gnu.org/licenses/gpl.html)
 *
 * @desc			jQuery.debug.sortPlugins
 */

jQuery.plugin( 'jQuery.debug.sortPlugins', function( $, undefined ){

	var listPlugins = function(){
			var data = {},
				ret = [];

			$.each( $.dependHandle.plugin._ready, function( name, deps ){
				if( !data[ name ] )
					data[ name ] = [];

				$.each( deps.plugin || [], function( i, dep ){
					if( !data[ dep ] )
						data[ dep ] = [];

					if( $.inArray( name, data[ dep ] )<=0 )
						data[ dep ].push( name );

				});
			});

			$.each( data, function( name, deps ){
				if( !(/^jQuery\.(ready|debug|provide)\..+$/).test(name) ){
					var i = ret.length,
						end;

					$.each( deps, function( k, dep ){
						k = $.inArray( dep, ret );
						i = k!=-1 && k<i ? k : i;
					});

					end = ret.splice( i, ret.length );
					ret.push( name );
					ret.push.apply( ret, end );
				}
			});

			return ret;
		};

	$.extend( $.debug, {
		// get an array of used plugins in the corrent dependencies order
		sortPlugins: function( depends, callback ){
			if( !callback ){
				callback = depends;
				depends = [];
			}

			$.ready( depends, function(){
				callback( listPlugins() );
			});
		}
	});

});