IF OBJECT_ID('i_Newsletter') IS NOT NULL
    DROP PROCEDURE i_Newsletter
GO
CREATE PROCEDURE i_Newsletter (
    @NewsletterID         int          
,   @NewsletterCampaignID int          
,   @IsHTML               bit          
,   @Name                 nvarchar(255) 
,   @Subject              nvarchar(255) = null
,   @SenderName           nvarchar(255) = null
,   @SenderEMail          varchar(255) = null
,   @ScheduleDate         datetime     = null
,   @SentDate             datetime     = null
,   @Status               tinyint      
,   @DeliveryInProgress   bit          
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_newsletter
    ELSE                     BEGIN TRANSACTION ti_newsletter

        INSERT INTO newsletter
               ( newsletterid, newslettercampaignid, ishtml, name, subject, sendername, senderemail, scheduledate, sentdate, status, deliveryinprogress)
        SELECT  @NewsletterID,@NewsletterCampaignID,@IsHTML,@Name,@Subject,@SenderName,@SenderEMail,@ScheduleDate,@SentDate,@Status,@DeliveryInProgress

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_newsletter
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_newsletter
    RETURN 0
END
GO
