IF OBJECT_ID('i_ShippingMethodCustomerGroup') IS NOT NULL
    DROP PROCEDURE i_ShippingMethodCustomerGroup
GO
CREATE PROCEDURE i_ShippingMethodCustomerGroup (
    @ShippingMethodID     int          
,   @CustomerGroupID      int          
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_shippingmethodcustomergroup
    ELSE                     BEGIN TRANSACTION ti_shippingmethodcustomergroup

        INSERT INTO shippingmethodcustomergroup
               ( shippingmethodid, customergroupid)
        SELECT  @ShippingMethodID,@CustomerGroupID

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_shippingmethodcustomergroup
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_shippingmethodcustomergroup
    RETURN 0
END
GO
