/*
 * @copyright		Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @odule			de_epages.shop.ui.userCommunityWidget
 *
 * @evision		$Revision: 1.1.6.3 $
 */

jQuery.plugin( 'de_epages.shop.ui.userCommunityWidget', {
	plugin:	['de_epages.core', 'jQuery.tmpl', 'jQuery.i18n', 'ep.date', 'ep.ui.tooltip', 'ep.fn.busy', 'de_epages.presentation.rss'],
	tmpl:	'de_epages.shop.ui.userCommunityWidget'
}, function( $, undefined ){

	$.widget( "de_epages.shop.ui.userCommunityWidget", {

		_feedData: null,

		options: { //define options of widget formally know as widget properties in dojo
			url: null,
			visibleEntrys: 3,
			entryLength: 50
		},

		_create: function(){
			if(!this.options.url){
				return;
			}
			ep(this.element.parent()).busy();
			//getFeedData
			var rss = new de_epages.presentation.Rss(this.options.url, $.proxy(this,'_readFeedData'));
		},

		_readFeedData: function(feedData){
			var items = feedData.items.slice(0,this.options.visibleEntrys);
			for(var i = 0, iLength = items.length; i < iLength; i++){
				var item = items[i];
				item.title = ep.scrunch(item.title,this.options.entryLength);
				item.text = ep.scrunch(item.text,this.options.entryLength);
			}
			var entrys = $.tmpl( 'de_epages.shop.ui.userCommunityWidget', {'items': items});
			entrys.appendTo(this.element);
			ep(this.element.parent()).busy('hide');
		},

		destroy: function(){
			this.element.remove();
		}

	});

});
