IF OBJECT_ID('i_ShopFeatureCollectionFeature') IS NOT NULL
    DROP PROCEDURE i_ShopFeatureCollectionFeature
GO
CREATE PROCEDURE i_ShopFeatureCollectionFeature (
    @CollectionID         int          
,   @FeatureID            int          
,   @MaxValue             int          
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_shopfeaturecollfeature
    ELSE                     BEGIN TRANSACTION ti_shopfeaturecollfeature

        INSERT INTO shopfeaturecollfeature
               ( collectionid, featureid, maxval)
        SELECT  @CollectionID,@FeatureID,@MaxValue

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_shopfeaturecollfeature
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_shopfeaturecollfeature
    RETURN 0
END
GO
